<?php

/* ----------------------------------------------------------------------------------
 *
 * Xaseco plugin paying coppers to a random player.
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			ML aka RookieNouse aka nouseforname @ http://www.tm-forum.com
 * Home: 			http://tmf.game-host.org
 * Date: 			19.09.2010
 * Version:			1.0
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */
  
Aseco::registerEvent('onEndRace', 'NouseRandomPay');
Aseco::registerEvent('onSync', 'NouseRandomPayUpToDate');

function NouseRandomPayUpToDate($aseco) {
    $aseco->plugin_versions[] = array(
        'plugin'	=> 'plugin.nouse.randompay.php',
        'author'	=> 'Nouseforname',
        'version'	=> '1.0.1'
    );
}

function NouseRandomPay ($aseco) {

$limit 				= 2; 		// player limit to enable random payment
$minservercoppers 	= 1000; 	// minimum amount of server coppers
$minpay 			= 20; 		// minimum amount to pay
$maxpay				= 150; 		// maximum amount to pay

$rocOnly 			= false; 	// set this to true if you want it only during 100k ladder state

/* ================================================================================= */
	
	if ($aseco->server->getGame() == 'TMF') {
		// check for TMUF server
		if ($aseco->server->rights) {	
			$active = false;
			$aseco->client->query('GetServerCoppers');
			$coppers = $aseco->client->getResponse();
			$aseco->client->query('GetLadderServerLimits');
			$ladderlimits = $aseco->client->getResponse();
			$ladder = $ladderlimits['LadderServerLimitMax'];
			if ($rocOnly == true && $ladder == 100000) {
				$active = true;
			} elseif ($rocOnly == false) {
				$active = true;
			}
		} else {
			$message = formatText($aseco->getChatMessage('UNITED_ONLY'), 'server');
			$this->Aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	} else {
		$message = $aseco->getChatMessage('FOREVER_ONLY');
		$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
	}
	
	if ($active) {
		if ($coppers >= $minservercoppers) {
			$ranking = array();
			$aseco->client->query('GetCurrentRanking', 200, 0);
			$ranking = $aseco->client->getResponse();
			$ranks = array();
			foreach ($ranking as $key => $var) {
				$rights = $aseco->server->players->getPlayer($var[Login])->rights;
				if ($rights && ($var[BestTime] > 0 || $var[Score] > 0)) {
					$ranks[] = array($var[Login], $var[NickName]);
				}
			}
			
			// check if enough players finished track
			if (count($ranks) >= $limit) {
				$x = mt_rand(0, (count($ranks)-1));
				$coppers = mt_rand($minpay, $maxpay);		
				if ($ranks[$x][0]) {
					$message = '$ff0> Lottery: '.$ranks[$x][1].' $g$z$6c0$s$iwon '.$coppers.' coppers!!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
					$message = 'You won '.$coppers.' coppers in lottery!'; 
					$aseco->client->addCall('Pay', array($ranks[$x][0], (int)$coppers, $aseco->formatColors($message)));	
				} 			
			}  
		} else {
			$message = '$ff0> $g$z$6c0$s$iServer coppers to low, random payment disabled. Please donate some.';
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	}
}
?>